var orgTspFileName = "16384.little_endian.wav";

window.onload = function() {
    //TFGraphInit("tfcanvasContainer", "tfcanvas");
};

function readfile(that) {
    var scope = angular.element(that).scope().readfile();
}

var debug;

////////////////////////////////////////////
// Controller of an application           //
////////////////////////////////////////////
angular.module('harktool', ["ui.bootstrap", 'ngMessages']).controller('tfgenCtrl', function($scope) {

    ////////////////////////////////////////////////////
    /// TF
    var orgTspPath = utilpath;
    if (orgTspPath)
        orgTspPath += orgTspFileName;
    else
        orgTspPath = orgTspFileName;
    $scope.confparams = {
        comment: { name: "Comment", value: "Generated by HARKTOOL5-GUI", inputtype: "text" },
        syncadd: { name: "Sync. Add Num", value: 16, inputtype: "number" },
        orgtsppath: { name: "Original TSP Path", value: orgTspPath, inputtype: "text" },
        tspoffset: { name: "TSP Offset", value: 16384, inputtype: "number", change: "changeTspLen()" },
        peakfrom: { name: "Peak Search From", value: 0, inputtype: "number" },
        peakto: { name: "Peak Search To", value: 0, inputtype: "number" },
        fftlen: { name: "FFT Length", value: 512, inputtype: "number" },
        samplingrate: { name: "Sampling Rate", value: 16000, inputtype: "number" },
        signalmax: { name: "Signal Max", value: 32768, inputtype: "number" },
        tsplength: { name: "TSP Length", value: 16384, inputtype: "number", change: "changeTspLen()" },
    };

    var micfilename = localStorage.getItem('micfile');
    var srcfilename = localStorage.getItem('srcfile');
    var srcfileinfo = localStorage.getItem('srcfileinfo');
    var srcfileinfoJson = (srcfileinfo) ? JSON.parse(srcfileinfo) : null;
    if (srcfileinfoJson.config) {
        $scope.confparams.comment.value = srcfileinfoJson.config.comment;
        $scope.confparams.syncadd.value = srcfileinfoJson.config.syncadd;
        $scope.confparams.orgtsppath.value = srcfileinfoJson.config.orgtsppath;
        $scope.confparams.tspoffset.value = srcfileinfoJson.config.tspoffset;
        $scope.confparams.peakfrom.value = srcfileinfoJson.config.peakfrom;
        $scope.confparams.peakto.value = srcfileinfoJson.config.peakto;
        $scope.confparams.fftlen.value = srcfileinfoJson.config.fftlen;
        $scope.confparams.samplingrate.value = srcfileinfoJson.config.samplingrate;
        $scope.confparams.signalmax.value = srcfileinfoJson.config.signalmax;
        $scope.confparams.tsplength.value = srcfileinfoJson.config.tsplength;
    }
    var tffilename = "tf.zip";

    var calcTypeList = [{ value: "calctfgeo", label: "Use Geometric Calculation" }];
    if (srcfileinfo && srcfileinfoJson.type === "tsp") {
        calcTypeList.splice(0, 0, { value: "calctfrec", label: "Use TSP Record Files" }, { value: "calctfmouth", label: "Use Mouth TSP Record Files" });
    } else if (srcfileinfo && srcfileinfoJson.type === "impulse") {
        calcTypeList.unshift({ value: "calctfimp", label: "Use Impulse Response Files" });
    }
    var yesnoList = [{ value: 1, label: "Yes" }, { value: 0, label: "No", selected: true }];
    var minMouthEnd = $scope.confparams.tspoffset.value + $scope.confparams.tsplength.value;
    $scope.tfparams = {
        zippath: { name: "Output File Name (zip)", value: tffilename, inputtype: "text", required: true },
        gtype: { name: "TF Calculation Type", value: calcTypeList[0].value, inputtype: "list", list: calcTypeList, change: "changeCalcType()" },
        mlist: { name: "Mic. Positions file", value: micfilename, inputtype: "text", readonly: true },
        slist: { name: "Source positions file", value: srcfilename, inputtype: "text", readonly: true },
        tftype: {
            name: "TF Type",
            value: "LOC_SEP",
            inputtype: "list",
            list: [
                { value: "LOC", label: "Localization" },
                { value: "SEP", label: "Separation" },
                { value: "LOC_SEP", label: "Localization and Separation", selected: true }
            ]
        },
        directlength: { name: "Direct Sound Length", inputtype: "number", value: 32 },
        reverblength: { name: "Reverb Sound Length", inputtype: "number", value: 256 },
        normsrc: { name: "Normalize SRC axis", value: 0, inputtype: "list", list: yesnoList },
        normmic: { name: "Normalize MIC axis", value: 0, inputtype: "list", list: yesnoList },
        normfreq: { name: "Normalize FREQ axis", value: 0, inputtype: "list", list: yesnoList },
        mouthstart: { name: "Mouth TSP Start", inputtype: "number", value: $scope.confparams.tspoffset.value, readonly: true },
        mouthend: { name: "Mouth TSP End", inputtype: "number", min: minMouthEnd, value: minMouthEnd },
        mch: { name: "Mouth TSP mch", inputtype: "number", value: 0, min: 0 },
        hop: { name: "Mouth TSP hop", inputtype: "number", value: 1000, min: 10 },
        headmargin: { name: "Mouth TSP Head Margin", inputtype: "number", value: 0 },
        resetmic: { name: "Reset Mic Channels", value: 0, inputtype: "list", list: yesnoList },
    };

    var setResult = function(state, title, msg) {
        if (state == "success") {
            $scope.gentfSuccess = true;
            $scope.gentfError = false;
        } else {
            $scope.gentfSuccess = false;
            $scope.gentfError = true;
            console.log(msg);
            $scope.errorMessageTitle = title;
            $scope.errorMessage = msg;
        }
        $scope.isRunning = false;
        $scope.$apply();
    };
    var clearResult = function() {
        $scope.gentfSuccess = false;
        $scope.gentfError = false;
    };

    var checkProgress = function() {
        var internal = function() {
            $.ajax({ url: "/progress" }).done(function(result) {
                console.log(result);
                $scope.progress = result + "%";
                $scope.$apply();
            });
            if (!$scope.gentfSuccess && !$scope.gentfError)
                setTimeout(internal, 1000);
        };
        if (!$scope.gentfSuccess && !$scope.gentfError)
            setTimeout(internal, 1000);
    };

    $scope.errorMessage = "no error";
    $scope.changeTspLen = function() {
        $scope.tfparams.mouthstart.value = $scope.confparams.tspoffset.value;
        if ($scope.tfparams.gtype.value === "calctfmouth")
            $scope.tfparams.mouthend.min = $scope.confparams.tspoffset.value + $scope.confparams.tsplength.value;
    };
    $scope.changeCalcType = function() {
        if ($scope.tfparams.gtype.value === "calctfgeo") {
            $scope.tfparams.reverblength.readonly = true;
            $scope.tfparams.normsrc.value = 1;
            $scope.tfparams.normsrc.readonly = true;
            $scope.tfparams.normmic.value = 1;
            $scope.tfparams.normmic.readonly = true;
            $scope.tfparams.normfreq.value = 1;
            $scope.tfparams.normfreq.readonly = true;
            $scope.tfparams.mouthstart.hide = true;
            $scope.tfparams.mouthend.hide = true;
            $scope.tfparams.mouthend.min = null;
            $scope.tfparams.mouthend.required = false;
            $scope.tfparams.mch.hide = true;
            $scope.tfparams.mch.required = false;
            $scope.tfparams.hop.hide = true;
            $scope.tfparams.hop.required = false;
            $scope.tfparams.headmargin.hide = true;
            $scope.tfparams.headmargin.required = false;
        } else if ($scope.tfparams.gtype.value === "calctfmouth") {
            $scope.tfparams.reverblength.readonly = false;
            $scope.tfparams.normsrc.readonly = false;
            $scope.tfparams.normmic.readonly = false;
            $scope.tfparams.normfreq.readonly = false;
            $scope.tfparams.mouthstart.hide = false;
            $scope.tfparams.mouthend.hide = false;
            $scope.tfparams.mouthend.min = $scope.confparams.tspoffset.value + $scope.confparams.tsplength.value;
            $scope.tfparams.mouthend.required = true;
            $scope.tfparams.mch.hide = false;
            $scope.tfparams.mch.required = true;
            $scope.tfparams.hop.hide = false;
            $scope.tfparams.hop.required = true;
            $scope.tfparams.headmargin.hide = false;
            $scope.tfparams.headmargin.required = true;
        } else {
            $scope.tfparams.reverblength.readonly = false;
            $scope.tfparams.normsrc.readonly = false;
            $scope.tfparams.normmic.readonly = false;
            $scope.tfparams.normfreq.readonly = false;
            $scope.tfparams.mouthstart.hide = true;
            $scope.tfparams.mouthend.hide = true;
            $scope.tfparams.mouthend.min = null;
            $scope.tfparams.mouthend.required = false;
            $scope.tfparams.mch.hide = true;
            $scope.tfparams.mch.required = false;
            $scope.tfparams.hop.hide = true;
            $scope.tfparams.hop.required = false;
            $scope.tfparams.headmargin.hide = true;
            $scope.tfparams.headmargin.required = false;
        }
    };

    $scope.readfile = function() {
        var filepath = $('#configfile').val();
        console.log("filepath=", filepath);
        var file = document.getElementById("configfile").files[0];
        if (file) {
            var url = URL.createObjectURL(file);
            Plotly.d3.xml(url, function(error, xmlRoot) {
                var elm;
                elm = xmlRoot.getElementsByTagName("comment");
                if (elm && elm[0] && elm[0].firstChild) {
                    $scope.confparams.comment.value = elm[0].firstChild.nodeValue;
                }
                elm = xmlRoot.getElementsByTagName("SynchronousAverage");
                if (elm && elm[0] && elm[0].firstChild && isFinite(elm[0].firstChild.nodeValue)) {
                    $scope.confparams.syncadd.value = Number(elm[0].firstChild.nodeValue);
                }
                elm = xmlRoot.getElementsByTagName("TSPpath");
                if (elm && elm[0] && elm[0].firstChild) {
                    $scope.confparams.orgtsppath.value = elm[0].firstChild.nodeValue;
                }
                elm = xmlRoot.getElementsByTagName("TSPOffset");
                if (elm && elm[0] && elm[0].firstChild && isFinite(elm[0].firstChild.nodeValue)) {
                    $scope.confparams.tspoffset.value = Number(elm[0].firstChild.nodeValue);
                }
                elm = xmlRoot.getElementsByTagName("PeakSearch");
                if (elm && elm[0] && isFinite(elm[0].getAttribute("from"))) {
                    $scope.confparams.peakfrom.value = Number(elm[0].getAttribute("from"));
                }
                if (elm && elm[0] && isFinite(elm[0].getAttribute("to"))) {
                    $scope.confparams.peakto.value = Number(elm[0].getAttribute("to"));
                }
                elm = xmlRoot.getElementsByTagName("nfft");
                if (elm && elm[0] && elm[0].firstChild && isFinite(elm[0].firstChild.nodeValue)) {
                    $scope.confparams.fftlen.value = Number(elm[0].firstChild.nodeValue);
                }
                elm = xmlRoot.getElementsByTagName("samplingRate");
                if (elm && elm[0] && elm[0].firstChild && isFinite(elm[0].firstChild.nodeValue)) {
                    $scope.confparams.samplingrate.value = Number(elm[0].firstChild.nodeValue);
                }
                elm = xmlRoot.getElementsByTagName("signalMax");
                if (elm && elm[0] && elm[0].firstChild && isFinite(elm[0].firstChild.nodeValue)) {
                    $scope.confparams.signalmax.value = Number(elm[0].firstChild.nodeValue);
                }
                elm = xmlRoot.getElementsByTagName("TSPLength");
                if (elm && elm[0] && elm[0].firstChild && isFinite(elm[0].firstChild.nodeValue)) {
                    $scope.confparams.tsplength.value = Number(elm[0].firstChild.nodeValue);
                }
                $scope.$apply();
                $('#configfile').val(""); // 同名fileを再度selectできるようにするworkaround
            });
        }
    };

    $scope.configDownload = function() {
        window.location.href = '/file/genconfig.xml';
    };


    ////////////////////////////////////////////////////
    ///
    /// create ボタン押下時
    ///
    $scope.genTF = function(formvalues, target) {
        $scope.isRunning = true;
        clearResult();

        console.log("@@@@=", $scope.tfparams.zippath.value);

        localStorage.setItem('tffile', $scope.tfparams.zippath.value);

        //merge
        var data = {};
        _.each($scope.confparams, function(val, key) {
            data[key] = val.value;
        });
        _.each($scope.tfparams, function(val, key) {
            data[key] = val.value;
        });

        console.log("@@@ genTF=", data);

        checkProgress();
        var errorTitle, errorTfFile;
        ajaxGenConfig(data)
            .then(function(res) { // genConfig done
                console.log("@@@@@@@@ genconfig success path=", res.path);
                return ajaxMergeXmls(data);
            }, function(res) { // genConfig fail
                errorTitle = 'Config generation';
                return Promise.reject(res);
            })
            .then(function(res) { // mergeXmls done
                data.slist = res.path; // update path for merged xml file
                console.log("@@@@@@@@ mergexmls success path=", res.path);
                return ajaxGenTf(data);
            }, function(res) { // mergeXmls fail
                if (!errorTitle)
                    errorTitle = 'XML Merge (Config + Source)';
                return Promise.reject(res);
            })
            .then(function(res) { // genTf done
                console.log("@@@@@@@@ gentf success path=", res.path);
                return ajaxValid('tf', { filename: res.path });
            }, function(res) { // genTf fail
                if (!errorTitle)
                    errorTitle = 'TF generation';
                errorTfFile = data.zippath;
                return Promise.reject(res);
            })
            .then(function(res) { // validTf done
                console.log("@@@@@@@@ validtf success");
                setValidSuccess('tf', data.zippath, res);
                setResult('success');
            })
            .catch(function(res) { // validTf fail
                if (!errorTitle)
                    errorTitle = 'TF validation';
                console.log(res);
                var errorMsg = (res.responseText) ? res.responseText : res.statusText;
                if (!errorTfFile)
                    setCreateError('tf', errorMsg);
                else
                    setValidError('tf', data.zippath, errorMsg);
                setResult('error', errorTitle, errorMsg);
            });
    };

    $scope.changeCalcType();
});
